<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [Ely](#ely)
    -   [mapIn](#mapin)
    -   [mapOut](#mapout)
    -   [map](#map)
    -   [unmap](#unmap)
    -   [defaultPatterns](#defaultpatterns)
    -   [findElyMapKey](#findelymapkey)
    -   [findEmptyKey](#findemptykey)
    -   [match](#match)
    -   [notmatch](#notmatch)
-   [Patterns](#patterns)
    -   [constructor](#constructor)
-   [StorageMap](#storagemap)
    -   [constructor](#constructor-1)

## Ely

Ely

Maps and unmaps object properties to emitter.
Every further change of properties will emit the changes.

Can keep the emitter inside or outside of the original object.

### mapIn

Maps and keeps emitter inside the object

Shortkey for map(object, true, patterns)

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties
-   `patterns` **[Patterns](#patterns)** patterns of matching (optional, default `undefined`)

Returns **EventEmitter** event emitter

### mapOut

Maps and keeps emitter outside the object

Shortkey for map(object, false, patterns)

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties
-   `patterns` **[Patterns](#patterns)** patterns of matching (optional, default `undefined`)

Returns **EventEmitter** event emitter

### map

Maps object properties

Main map method

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties
-   `embed` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** embed the emitter or not (optional, default `true`)
-   `patterns` **[Patterns](#patterns)** patterns of matching (optional, default `undefined`)

Returns **EventEmitter** event emitter

### unmap

Unmaps object properties

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties

### defaultPatterns

Gets default pattern

Returns **[Patterns](#patterns)** default patterns

### findElyMapKey

Finds the ely map key

Checks if default ely map key already exists and replaces
it with unique one.

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties

Returns **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** 

### findEmptyKey

Finds empty key

Checks if key overlap inside object. Creates unique one if needed.

**Parameters**

-   `object` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)** object with properties
-   `key` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** key to be checked
-   `prefix` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** prefix to be applied

Returns **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** unique key

### match

Matches key to pattern

Checks if key matches a given pattern

**Parameters**

-   `key` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** key to be checked
-   `patterns` **[Patterns](#patterns)** patterns to check against

Returns **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** match result

### notmatch

No Matches key to pattern

Checks if key does not match a given pattern

**Parameters**

-   `key` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** key to be checked
-   `patterns` **[Patterns](#patterns)** patterns to check against

Returns **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** match result

## Patterns

Patterns

Patterns for matching.

**Parameters**

-   `accept` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for accept
-   `skip` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for skip
-   `emitall` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** emitall status (optional, default `false`)

### constructor

Patterns constructor

**Parameters**

-   `accept` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for accept
-   `skip` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for skip
-   `emitall` **[boolean](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** emitall status (optional, default `false`)

## StorageMap

StorageMap

Storage map for properties

### constructor

StorageMap constructor
